#!/bin/bash

country_name=$1 #"nigeria"
periods=$2


# echo "$country_name" | sed -e 's/\(.*\)/\U\1/'
Country_name=`echo "$country_name" | sed 's/./\u&/'`
pix_coord_file="ToolKit/fix/${country_name}_stns_pixel_info.txt"


#readarray -t pixinfo < "${pix_coord_file}" 

i=0;while IFS= read -r pixinfo[i++]; do :; done <${pix_coord_file}

npixtot=$(cat "${pix_coord_file}" | wc -l)  	#### TOTAL NUMBER OF ROW IN THE FILE
echo "========== The total number of station is : $npixtot"
# exit
ipix=0
flag="ok"
while [ $ipix -lt $npixtot ]
  do
#     echo ${pixinfo[$ipix]} | awk '{for (f=1;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=1;f<=NF;f++) print col[f]}' | tr ':' ' '
# #     exit
    echo ${pixinfo[$ipix]} | awk '{for (f=1;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=1;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt

    declare -a valn0=(`cat bd.txt`)
    rm -f bd.txt
# 
#     pixnum=${valn0[0]}  
#     xpixcoord=${valn0[7]}     
#     ypixcoord=${valn0[8]}     
#     gridtype=${valn0[9]}     
    ######### Remove all non-printable character from the variable ###########################
    pixnum=`echo "${valn0[0]}" | tr -cd [:print:]`
    xpixcoord=`echo "${valn0[3]}" | tr -cd [:print:]`
    ypixcoord=`echo "${valn0[4]}" | tr -cd [:print:]`
    gridtype=`echo "${valn0[5]}" | tr -cd [:print:]`
#      echo "--------$gridtype----------"   

# cat > line_of_pix_body.html << EOF
# <area href="${pixnum}_${periods}.png" shape="circle" coords="${xpixcoord}, ${ypixcoord},  5" TITLE="$gridtype">
# EOF


if [ $periods = "rev" ]
    then

cat > line_of_pix_body.html << EOF
<area href="${gridtype}.png" shape="circle" coords="${xpixcoord}, ${ypixcoord},  5" TITLE="$gridtype">
EOF

else

cat > line_of_pix_body.html << EOF
<area href="${gridtype}_${periods}_days.png" shape="circle" coords="${xpixcoord}, ${ypixcoord},  5" TITLE="$gridtype">
EOF

fi

    if [ $flag = "ok" ]
        then
        cp line_of_pix_body.html all_lines_pix_body.html
        flag="no"
    else
        cat line_of_pix_body.html >> all_lines_pix_body.html
    fi
    rm -f line_of_pix_body.html
    ipix=$[$ipix+1]
done


##############################################################################################################################
############################################## FIRST LINES OF THE HTML FILE ##################################################
##############################################################################################################################
cat > first_line_pix_body.html << EOF


 <table border="0" width="510" bgcolor="FFFFFF" align="center" cellpadding=5>
 <tr>
  <td align="center">
  <h3>Rainfall Time Series for the Last ${periods} Days at Stations Locations</h3>
</td></tr></table>


          <table border="0" width="490" bgcolor="FFFFFF" align="center" cellpadding=5>
 <tr>
 
  <td align="center"><MAP NAME="${country_name}_rfe_${periods}">
EOF


##############################################################################################################################
############################################## LAST LINES OF THE HTML FILE ###################################################
##############################################################################################################################
cat > last_line_pix_body.html << EOF
</MAP>
<img src="${country_name}_grid.png" alt="${Country_name}" border="1" usemap="#${country_name}_rfe_${periods}">  </td>
 </tr>
          </table>
EOF


cat all_lines_pix_body.html >> first_line_pix_body.html
cat last_line_pix_body.html >> first_line_pix_body.html

mv first_line_pix_body.html template_pix_body.html
rm -f all_lines_pix_body.html last_line_pix_body.html


if [ $periods = "rev" ]
    then
    cp template_pix_body.html ToolKit/fix/${country_name}_pix_${periods}_body.html
    mv template_pix_body.html ToolKit/ts_maps/${country_name}/pix_${periods}_body.html
else
    cp template_pix_body.html ToolKit/fix/${country_name}_pix_${periods}day_body.html
    mv template_pix_body.html ToolKit/ts_maps/${country_name}/pix_${periods}day_body.html
fi

