	#include <stdio.h>

	struct rpthdr {
	  char id[8];           /* Character station id  */
	  float lat;            /* Latitude of report             */
	  float lon;            /* Longitude of report            */
	  float t;              /* Time in relative grid units    */
	  int  nlev;            /* Number of levels following     */
	  int flag;             /* Level independent var set flag */
	} hdr;

	void main () {

	  FILE *ifile, *ofile;

	  char rec[80];
	  int flag,year,month,day,yrsav,mnsav,dysav,i;
	  float val;

	  ifile = fopen ("data_clim_for_map.txt","r");
	  ofile = fopen ("data_clim_for_map.bin","wb");

	  if (ifile==NULL || ofile==NULL) {
	    printf ("Error input file\n");
	    return;
	  }

	  flag = 1;

	  while (fgets(rec,79,ifile) != NULL){

	    sscanf (rec,"%i %i %i",&year,&month,&day);
	    sscanf (rec+28," %g %g %g",&hdr.lat,&hdr.lon,&val);

	    for (i=0;i<8;i++) 
	     hdr.id[i] = rec[i+21];

	     if(flag) {
	     yrsav = year;
	     mnsav = month;
	     dysav = day;
	     flag = 0;
	     }

	     if (yrsav!=year || mnsav!=month || dysav!=day) {
	     hdr.nlev = 0;
	     fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	     }
	     yrsav = year; 
	     mnsav = month;
	     dysav = day;

	     hdr.nlev = 1;
	     hdr.flag = 1;
	     hdr.t = 0.0;

	    fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	    fwrite (&val,sizeof(float), 1, ofile);
	  }

	  hdr.nlev = 0;
	  fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	}
