latlon='../input_data/CONTRY_latlon'
stnfile='../input_data/CONTRY_stns_latlon.txt'

nd = tpr
*******************************************
xtnd=read(latlon)
  rstr=sublin(xtnd,2)
  country=subwrd(rstr,1)
  lat1=subwrd(rstr,2)
  lat2=subwrd(rstr,3)
  lon1=subwrd(rstr,4)
  lon2=subwrd(rstr,5)
  xlnt=subwrd(rstr,6)
  ylnt=subwrd(rstr,7)
xtnd = close(latlon)
*******************************************

'set display color white'
'clear'

stnmark=STNMRKOPT
if(stnmark=0)
  'open ../ToolKit/gis_resources/country_masks0p036/CONTRY_0p036.ctl'
  'define fmask = mask(t=1)'
  'close 1'
  'open ../ToolKit/gis_resources/country_masks0p5/CONTRY_0p5.ctl'
  'open stn_rain_index.ctl'
  
  'define imask = mask.1(t=1)'
  
  'define totnrd=oacres(imask,totnrd.2(t=1))'
  'define clmtotnrd=oacres(imask,clmtotnrd.2(t=1))'
  'define tothrd=oacres(imask,tothrd.2(t=1))'
  'define totvhrd=oacres(imask,totvhrd.2(t=1))'
  'define maxcwd=oacres(imask,maxcwd.2(t=1))'
  'define maxcdd=oacres(imask,maxcdd.2(t=1))'
  'define maxchrd=oacres(imask,maxchrd.2(t=1))'
  'define maxcvhrd=oacres(imask,maxcvhrd.2(t=1))'
  
  'define totnrd=maskout(lterp(totnrd,fmask),fmask)'
  'define clmtotnrd=maskout(lterp(clmtotnrd,fmask),fmask)'
  'define tothrd=maskout(lterp(tothrd,fmask),fmask)'
  'define totvhrd=maskout(lterp(totvhrd,fmask),fmask)'
  'define maxcwd=maskout(lterp(maxcwd,fmask),fmask)'
  'define maxcdd=maskout(lterp(maxcdd,fmask),fmask)'
  'define maxchrd=maskout(lterp(maxchrd,fmask),fmask)'
  'define maxcvhrd=maskout(lterp(maxcvhrd,fmask),fmask)'
else
 'open stn_rain_index.ctl'
endif
*

'set lat 'lat1' 'lat2''
'set lon 'lon1' 'lon2''

ylint = (lat2 - lat1)/4
xlint = (lon2 - lon1)/4

xlint = math_int(math_abs(xlint))
ylint = math_int(math_abs(ylint))


'exec colors'
'set string 1 c 1 0'
*'set stid on'

***************************** Plot the total number of wet days *****************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

'set clevs 0.5 3 6 10 15 20 30 45 60'
if (nd > 100)
'set clevs 1 6 12 20 30 40 60 90 120'
endif

'set ccols 73 31 35 38 42 45 48 51 53 55'
*'set ccols 95 31 35 38 42 45 48 51 53 55'

'd totnrd'


** ------ Figure out where the title will go -------------------------
'q gxinfo'
xlims=sublin(result,3)
ylims=sublin(result,4)
ytop=subwrd(ylims,6)
xleft=subwrd(xlims,4)
xright=subwrd(xlims,6)
xmid=xleft+(xright-xleft)/2

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Total Number of Rain Days'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_rain_day.png '
'!convert -trim -density 500 CONTRY_rev_stn_rain_day.png CONTRY_rev_stn_rain_day.png'
'clear'

***************************** Plot the total number of wet days anomaly *****************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

*'set clevs  -100 -75 -50 -25 -15 -5 5 15 25 50 75 100'
'set clevs  -20 -15 -10 -6 -3 -1 1 3 6 10 15 20'
'set ccols 21 78 76 75 74 72 0 31 34 39 42 44 49'

'd totnrd-clmtotnrd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Tot. Num. of Rain Days Anom.'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_rain_day_anom.png '
'!convert -trim -density 500 CONTRY_rev_stn_rain_day_anom.png CONTRY_rev_stn_rain_day_anom.png'
'clear'

***************************** Plot the total number of Heavy Precipitation days *****************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

'set clevs 0.5 3 6 10 15 20 30 45 60'
'set ccols 0 31 35 38 42 45 48 51 53 55'

'd tothrd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Total Num. of HRD'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_HVrain_day.png '
'!convert -trim -density 500 CONTRY_rev_stn_HVrain_day.png CONTRY_rev_stn_HVrain_day.png'
'clear'

***************************** Plot the total number of Very Heavy Precipitation days *****************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

'set clevs 0.5 3 6 10 15 20 30 45 60'
'set ccols 0 31 35 38 42 45 48 51 53 55'

'd totvhrd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Total Num. of VHRD'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_VHvrain_day.png '
'!convert -trim -density 500 CONTRY_rev_stn_VHvrain_day.png CONTRY_rev_stn_VHvrain_day.png'
'clear'

***************************** Plot the Maximum number of consecutive wet days ************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

'set clevs 0.5 3 7 10 15 20 30 45 60'
'set ccols 95 31 35 38 42 45 48 51 53 55'

'd maxcwd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Max. Cons. Num. of Wet Days'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_rain_maxCWobs.png '
'!convert -trim -density 500 CONTRY_rev_stn_rain_maxCWobs.png CONTRY_rev_stn_rain_maxCWobs.png'
'clear'

***************************** Plot the Maximum number of consecutive dry days ************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

'set clevs 0 3 7 10 15 20 30 45 60'
'set ccols  0  71 73 76 79 21 23 25 27 29'
*'set ccols 95 31 35 38 41 45 48 51 53 55'

'd maxcdd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Max. Cons. Num. of Dry Days'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_rain_maxCDobs.png '
'!convert -trim -density 500 CONTRY_rev_stn_rain_maxCDobs.png CONTRY_rev_stn_rain_maxCDobs.png'
'clear'

***************************** Plot the Maximum number of consecutive Heavy rain days ************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

*'set clevs 0 3 7 10 15 20 30 45 60'
*'set ccols  0  71 73 76 79 21 23 25 27 29'

*'set clevs 0.5 3 7 10 15 20 30 45 60'
'set clevs    0.5 1  2  3  4  5  6  7  8'
'set ccols 0  31 35 38 42 45 48 51 53 55'


'd maxchrd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Max. Cons. Num. of HRD'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_rain_maxCHVRobs.png '
'!convert -trim -density 500 CONTRY_rev_stn_rain_maxCHVRobs.png CONTRY_rev_stn_rain_maxCHVRobs.png'
'clear'

***************************** Plot the Maximum number of consecutive Very Heavy rain days ************************
'set mpdraw off'
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

*'set clevs 0 3 7 10 15 20 30 45 60'
*'set ccols  0  71 73 76 79 21 23 25 27 29'

*'set clevs 0.5 3 7 10 15 20 30 45 60'
'set clevs    0.5 1  2  3  4  5  6  7  8'
'set ccols 0  31 35 38 42 45 48 51 53 55'

'd maxcvhrd'

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Max. Cons. Num. of VHRD'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'
'printim CONTRY_rev_stn_rain_maxCVHVRobs.png '
'!convert -trim -density 500 CONTRY_rev_stn_rain_maxCVHVRobs.png CONTRY_rev_stn_rain_maxCVHVRobs.png'
'clear'
*
'quit'
