'open daily_data.ctl'
*'open daily_clim.ctl'
*'set fwrite scratch.bin'
*'set gxout fwrite'
*
stn='STNAME'
stnid=STID
stnlat=SLAT
stnlon=SLON
clmyr1=CLMYEAR1
clmyr2=CLMYEAR2
*Nclmyr=clmyr2-clmyr1+1
*----------------------------
'set time date1 date2'
'q dims'
timlin = sublin(result,5) 
tstep1=subwrd(timlin,11);tstep2=subwrd(timlin,13)
tstep = subwrd(timlin,6);yrtstep1 = substr(tstep,9,12)
tstep = subwrd(timlin,8);yrtstep2 = substr(tstep,9,12)
strdate=subwrd(timlin,6);strtdte1=substr(strdate,4,9)
TOTt=tstep2
*

*-----------------------------
'set x 1'
'set y 1'
'set z 1'
'define obs = 'stn'.1'
*'define clm = 'stn'.2'

********************************************************************************************
* Identify the Rain Day - Compute the corresponding total number and the anomaly over periods 
********************************************************************************************
'define obsrainy = const(const(maskout(obs,obs-1.),1),0,-u)'
*'define clmrainy = const(const(maskout(clm,clm-5.),1),0,-u)'

'define obsHR  = const(const(maskout(obs,obs-10.),1),0,-u)'
'define obsVHR = const(const(maskout(obs,obs-20.),1),0,-u)'

'set t 1'
'define totobsrainday = sum(obsrainy,time=date1,time=date2)'
'define totHRD       = sum(obsHR,time=date1,time=date2)'
'define totVHRD      = sum(obsVHR,time=date1,time=date2)'

'define totclmrainday = totobsrainday*0'
yr1=clmyr1
yr2=yr1+(yrtstep2-yrtstep1)
*if(yrtstep2 = yrtstep1); yr2=yr1; endif
*if(yrtstep2 > yrtstep1); yr2=yr1+1; endif
Nclmyr=0
while(yr2<=clmyr2)
    Nclmyr=Nclmyr+1
    'set time DDMM1'yr1' DDMM2'yr2''
    'define yrobsrainy = if('stn'.1,>=,1.,1.,0)'
*    'define obs = 'stn'.1'
*    'define yrobsrainy = const(const(maskout(obs,obs-1.),1),0,-u)'
    'set t 1'
    'define totclmrainday = totclmrainday + sum(yrobsrainy,time=DDMM1'yr1',time=DDMM2'yr2')'
    yr1=yr1+1
    yr2=yr1+(yrtstep2-yrtstep1)
*    if(yrtstep2 = yrtstep1); yr2=yr1; endif
*    if(yrtstep2 > yrtstep1); yr2=yr1+1; endif
endwhile
'set t 1'
'define totclmrainday = totclmrainday / 'Nclmyr

********************************************************************************************
**** Compute the Maximum Consecutive Number of Wet Days 
********************************************************************************************
'define counterwet = totobsrainday*0'
'define counterdry = totobsrainday*0'
'define counterhvr = totobsrainday*0'
'define countervhvr = totobsrainday*0'

tim = tstep1
while(tim <= tstep2)
 'set t 'tim
 'q time'
* say "-----------" tim
 timlin = sublin(result,1); xdate=subwrd(timlin,3)
 xdday=substr(xdate,4,2);xmthstr=substr(xdate,6,3);xyr=substr(xdate,9,4)

 if(xmthstr='JAN'); xmth='01'; endif
 if(xmthstr='FEB'); xmth='02'; endif
 if(xmthstr='MAR'); xmth='03'; endif
 if(xmthstr='APR'); xmth='04'; endif
 if(xmthstr='MAY'); xmth='05'; endif
 if(xmthstr='JUN'); xmth='06'; endif
 if(xmthstr='JUL'); xmth='07'; endif
 if(xmthstr='AUG'); xmth='08'; endif
 if(xmthstr='SEP'); xmth='09'; endif
 if(xmthstr='OCT'); xmth='10'; endif
 if(xmthstr='NOV'); xmth='11'; endif
 if(xmthstr='DEC'); xmth='12'; endif

 'define counterwet = if(obsrainy,=,1,counterwet+1,0)'
 'define wetday     = if(obsrainy,=,1,counterwet,0)'

 'define counterdry = if(obsrainy,=,0,counterdry+1,0)'
 'define dryday     = if(obsrainy,=,0,counterdry,0)'

 'define counterhvr = if(obsHR,=,1,counterhvr+1,0)'
 'define hvrday     = if(obsHR,=,1,counterhvr,0)'
 
 'define countervhvr = if(obsVHR,=,1,countervhvr+1,0)'
 'define vhvrday     = if(obsVHR,=,1,countervhvr,0)'
 
 'set gxout fwrite'
 'set fwrite tally_wet_dry_bin.'xyr''xmth''xdday'.dat'
 'set undef -99999.0'
 'd wetday'
 'd dryday'
 'd hvrday'
 'd vhvrday'
 
 'disable fwrite'
 tim = tim + 1
endwhile

*--------- create the .ctl to manage the binary file ------------------------------------
    savectlfile="tally_wet_dry.ctl"
    recl=write(savectlfile,'dset ^tally_wet_dry_bin.%y4%m2%d2.dat')
    recl=write(savectlfile,'title total number of Consecutive Days',append)
    recl=write(savectlfile,'options template 365_day_calendar',append)
    recl=write(savectlfile,'undef 99999.0',append)
    recl=write(savectlfile,'xdef 1 linear 1 1',append)
    recl=write(savectlfile,'ydef 1 linear 1 1',append)
    recl=write(savectlfile,'zdef 1 linear 1 1',append)
    recl=write(savectlfile,'tdef 'TOTt' linear 'strtdte1' 1dy',append)
    recl=write(savectlfile,'vars 4',append)
    recl=write(savectlfile,'cwd 0 99 Number of Consecutive Wet Days',append)
    recl=write(savectlfile,'cdd 0 99 Number of Consecutive Dry Days',append)
    recl=write(savectlfile,'hvrd 0 99 Number of Consecutive Heavy Rain Days',append)
    recl=write(savectlfile,'vhrd 0 99 Number of Consecutive Very Heavy Rain Days',append)
    recl=write(savectlfile,'endvars')
    ret0=close(savectlfile)



'open tally_wet_dry.ctl'
'define cwd = max(cwd.2,time=date1,time=date2)'
'define cdd = max(cdd.2,time=date1,time=date2)'
'define chvrd = max(hvrd.2,time=date1,time=date2)'
'define cvhrd = max(vhrd.2,time=date1,time=date2)'
 
'set gxout shaded'
'set undef -99999.0'

'd totobsrainday'
tord = subwrd(result,4)
*say '----tot rain days                : 'tord

'd totclmrainday'
toclmrd = subwrd(result,4)
*say '----clim tot rain days           : 'toclmrd

'd totHRD'
totHRD = subwrd(result,4)
*say '----tot heavy rain days          : 'totHRD

'd totVHRD'
totVHRD = subwrd(result,4)
*say '----tot very heavy rain days     : 'totVHRD

'd cwd'
cwd = subwrd(result,4)
*say '----max cons wet days            : 'cwd

'd cdd'
cdd = subwrd(result,4)
*say '----max cons dry days            : 'cdd

'd chvrd'
chvrd = subwrd(result,4)
*say '----max cons heav rain days      : 'chvrd

'd cvhrd'
cvhrd = subwrd(result,4)
*say '----max cons very heav rain days : 'cvhrd

'close 2'

************************************************************************************************************************************************
************************************************************************************************************************************************
************ SAVE ALL THE RAINFALL INDEX IN A SINGLE TEXT FILE *********************************************************************************
************************************************************************************************************************************************
************************************************************************************************************************************************
ret = read('stn_rain_index.txt')
rc  = sublin(ret,1)
if(rc!=0)
  rec=write('stn_rain_index.txt',1981' '01' '01' 'stnid' 'stnlat' 'stnlon' 'tord' 'toclmrd' 'totHRD' 'totVHRD' 'cwd' 'cdd' 'chvrd' 'cvhrd)
endif
if(rc=0)
  recl=close('stn_rain_index.txt')
  rec=write('stn_rain_index.txt',1981' '01' '01' 'stnid' 'stnlat' 'stnlon' 'tord' 'toclmrd' 'totHRD' 'totVHRD' 'cwd' 'cdd' 'chvrd' 'cvhrd,append)
endif


'!rm -f tally_wet_dry_bin.*.dat tally_wet_dry.ctl'
'quit'
