#!/bin/bash

trgtcontry=$1     # country name eg .nigeria
seas_desc=$2
mth1_desc=$3
mth2_desc=$4
mth3_desc=$5
######################### generate html files to for grid and station time series and cumulatives curves ##############################


if [ "$#" -lt 2 ]; then
    
    mkdir -p ToolKit/ts_maps/${trgtcontry}
    mkdir -p ToolKit/spatial_maps/${trgtcontry}

#     bash generate_template_pix_body.sh ${trgtcontry} 7
#     bash generate_template_pix_body.sh ${trgtcontry} 10
#     bash generate_template_pix_body.sh ${trgtcontry} 30
#     bash generate_template_pix_body.sh ${trgtcontry} 60
#     bash generate_template_pix_body.sh ${trgtcontry} 90
#     bash generate_template_pix_body.sh ${trgtcontry} 180
    bash generate_template_pix_body.sh ${trgtcontry} rev

    cd ToolKit

#     cp template_country_index.html ${trgtcontry}_index.html 
#     sed -i "s|COUNTRY|${trgtcontry}|g" ${trgtcontry}_index.html
#     sed -i "s|CONTRY|${trgtcontry^^}|g" ${trgtcontry}_index.html

    cp fix/${trgtcontry}_grid.png ts_maps/${trgtcontry}/.
    
else
    if [ "$#" -eq 5 ]; then
        mkdir -p ToolKit/ts_maps/${trgtcontry}/season_review
        mkdir -p ToolKit/spatial_maps/${trgtcontry}/season_review
        
        ./generate_template_pix_body_seas_review.sh ${trgtcontry} ${mth1_desc}-${mth3_desc} season
        ./generate_template_pix_body_seas_review.sh ${trgtcontry} ${mth1_desc} MTH1
        ./generate_template_pix_body_seas_review.sh ${trgtcontry} ${mth2_desc} MTH2
        ./generate_template_pix_body_seas_review.sh ${trgtcontry} ${mth3_desc} MTH3

        cd ToolKit
        
        cp template_country_seas_review_index.html ${trgtcontry}_seas_review_index.html 
        sed -i "s|COUNTRY|${trgtcontry}|g;s|CONTRY|${trgtcontry^^}|g" ${trgtcontry}_seas_review_index.html
        sed -i "s|SEASONSTR|${mth1_desc}-${mth3_desc}|g;s|MTH1STR|${mth1_desc}|g;s|MTH2STR|${mth2_desc}|g;s|MTH3STR|${mth3_desc}|g" ${trgtcontry}_seas_review_index.html

        cp fix/${trgtcontry}_grid.png ts_maps/${trgtcontry}/season_review/
    fi
fi
