#!/bin/bash
LANG=en_US.utf8 
unameout="$(uname -s)"

trgtcontry=$1                   #nigeria
cntryisocode=$2                 #NGA

# trgtcontry=ethiopia
# cntryisocode=ETH

if [ $unameout = "Darwin" ]; then
    opt="bk"
fi

#==========================================================================================================================================================================================
echo "..................... Generating the folder Some Mask files ..................................................................................................."
sleep 1
bash script_generate_mask.sh ${trgtcontry} ${cntryisocode} 
sleep 2

#==========================================================================================================================================================================================
cd ToolKit 

rm -rf ${trgtcontry}_stns_map

echo "..................... Generating the folder ${trgtcontry}_stns_map ..................................................................................................."
sleep 2
cp -R template_country_stn_map ${trgtcontry}_stns_map

echo "------------------------- Moving under the Sub Direictory ${trgtcontry}_stns_map, Once there :  ------------------------------------------------------------------"
cd ${trgtcontry}_stns_map

echo "------------------------- Now, Used template_country_stationmap.gs for the creation and edition of the file ${trgtcontry}_stationmap.gs  ----------------------------------"
stationinfo="../../input_data/${trgtcontry}_stns_latlon.txt"
nstns=$(cat "${stationinfo}" | wc -l)  	####  TOTAL NUMBER OF ROW IN THE FILE
                                        ##### .i.e Total Number of Stations 
            
cp template_country_stationmap.gs               ${trgtcontry}_stationmap.gs
sed -i $opt "s|COUNTRY|${trgtcontry}|g"              ${trgtcontry}_stationmap.gs
sed -i $opt "s|CNTRYISOCODE|${cntryisocode}|g"       ${trgtcontry}_stationmap.gs
sed -i $opt "s|nstns|${nstns}|g"                     ${trgtcontry}_stationmap.gs
sleep 1
echo 

echo "------------------------- Generation of a ${gr} resolution representing grid and station point over of ${trgtcontry} --------------------------------------------------"
echo
grads -blc ${trgtcontry}_stationmap.gs



echo "------------------------- Using template_grads_wrld2pix_coord.gs to create ../fix/${trgtcontry}_stns_pixel_info.txt containing the stations pixels informations ------------"

cp template_grads_wrld2pix_coord.gs grads_world2pix_coord.gs
sed -i $opt "s|COUNTRY|${trgtcontry}|g" grads_world2pix_coord.gs
sed -i $opt "s|nstns|${nstns}|g" grads_world2pix_coord.gs
rm -f pixelarguments.txt

grads -blc grads_world2pix_coord.gs

rm -f grads_world2pix_coord.gs *.gsbk

mkdir ../fix 
mv pixelarguments.txt ../fix/${trgtcontry}_stns_pixel_info.txt
cp -f ${trgtcontry}_grid.png ../fix/.





# ./create_stnmap.sh ${trgtcontry} ${gr}

# cp ${trgtcontry}_grid.png ../../ts_maps/${trgtcontry}/.

