        program read
c-----------------------------------------------------------
c ....  ny=number of years
c ....  ns=number of stations
c ....  ist=starting year of data
c ....  jdy=number of julian days (non leap years only)
c-----------------------------------------------------------
        parameter (ny=40,ns=2,ist=1971) ! **** Change this line if needed
        parameter (ndy=365)  ! Do not Change this line
c
        real b(ns,ndy,ny),c(ndy,ny), d(ndy), cc(ns)
        real dd(ns,ndy)
        real xlat(ns),xlon(ns)
        integer yr, mn, lyy(ny)
        character*8 stnn(ns)
        character*18 ifile
        ifile="formatted_data.txt"
c..
c..****If needed, change following input and output file names  ****
c..
        open(10,file=ifile,form='formatted',status='old')
        open(20,file='StnData_daily_clim.asc',
     1  form='formatted',status='unknown')
        open(21,file='StnData_daily_data.asc',
     1  form='formatted',status='unknown')
        open(30,file='StnData_daily_clim.bin',
     1  form='unformatted',access='direct',recl=4*ns,status='unknown')
        open(40,file='StnData_daily_data.bin',
     1  form='unformatted',access='direct',recl=4*ns,status='unknown')

        iyy=ist-1
        do iy=1,ny
          iyy=iyy+1
          lyy(iy)=iyy
        enddo
c
c-- Do not change below this line----------------------
c
        do is=1,ns
         read(10,103) xlat(is),xlon(is),stnn(is)
         read(10,334) (lyy(iy),iy=1,ny)
        do idy=1,ndy
         read(10,333) (c(idy,iy),iy=1,ny)
       do iy=1,ny
           if(c(idy,iy).gt.2500) c(idy,iy)=-99999.0
       enddo
        enddo
c
        iyy=ist-1
        do iy=1,ny
        iyy=iyy+1
        write(21,104) xlat(is),xlon(is),stnn(is),iyy
        write(21,101) (c(idy,iy),idy=1,ndy)
        enddo
c-----------------
        do idy=1,ndy
        do iy=1,ny
          b(is,idy,iy)=c(idy,iy)
        enddo
        enddo
c----------------- climatological periode
        do idy=1,ndy
        sum=0.0
        ic=0
c..climatology 1981-2010
        do iy=11,ny
c..climatology 1961-2015
c       do iy=1,ny-1
         if(c(idy,iy).eq.-99999.0) goto 224
          ic=ic+1
          sum=sum+c(idy,iy)
 224    continue
        enddo
          d(idy)=sum/float(ic)
            if(d(idy).lt.0.0) d(idy)=-99999.0
          dd(is,idy)=d(idy)
        enddo
        write(20,103) xlat(is),xlon(is),stnn(is)
        write(20,101) (d(idy),idy=1,ndy)
c
        enddo !----end stations loop
c
c...writing binary data file
        irec=0
        do iy=1,ny
        do idy=1,ndy
          do is=1,ns
            cc(is)=b(is,idy,iy)
          enddo
          irec=irec+1
          write(40,rec=irec) cc
        enddo
        enddo
c
c...writing climatology binary file
        irec=0
        do idy=1,ndy
        irec=irec+1
        do is=1,ns
          cc(is)=dd(is,idy)
        enddo
          write(30,rec=irec) cc
        enddo
        do idy=1,ndy
        irec=irec+1
        do is=1,ns
          cc(is)=dd(is,idy)
        enddo
          write(30,rec=irec) cc
        enddo

c
c-----------------
c
 100    format(a80)
 101    format(12f10.2)
 103    format(2f10.2,a8)
 104    format(2f10.2,a8,2x,i4)
 333    format(55f10.2)
 334    format(55i10)

c
        stop
        end

