latlon='../input_data/CONTRY_latlon'
stnfile='../input_data/CONTRY_stns_latlon.txt'

nd = tpr
*******************************************
xtnd=read(latlon)
  rstr=sublin(xtnd,2)
  country=subwrd(rstr,1)
  lat1=subwrd(rstr,2)
  lat2=subwrd(rstr,3)
  lon1=subwrd(rstr,4)
  lon2=subwrd(rstr,5)
  xlnt=subwrd(rstr,6)
  ylnt=subwrd(rstr,7)
xtnd = close(latlon)
*******************************************

'set display color white'
'clear'


stnmark=STNMRKOPT

if(stnmark=0)
  'open ../ToolKit/gis_resources/country_masks0p036/CONTRY_0p036.ctl'
  'define fmask = mask(t=1)'
  'close 1'
  'open ../ToolKit/gis_resources/country_masks0p5/CONTRY_0p5.ctl'
  'open data_for_map.ctl'
  'open data_clim_for_map.ctl'
  
  'define imask = mask.1(t=1)'
  
  'define ptot=oacres(imask,tpr*stnave(precip.2, time=date1,time=date2,-m 2))'
  'define pclim=oacres(imask,tpr*stnave(precip.3, time=date1,time=date2,-m 2))'
  'define ptot  = maskout(lterp(ptot,fmask),fmask)'
  'define pclim = maskout(lterp(pclim,fmask),fmask)'

  'define panom = ptot-pclim'
  'define pnorm = ptot*100./pclim'
  if (nd > 100)
   'define ptot=ptot*0.1'
   'define pclim=pclim*0.1'
  endif
else
  'open data_for_map.ctl'
  'open data_clim_for_map.ctl'
endif

'set lat 'lat1' 'lat2''
'set lon 'lon1' 'lon2''

ylint = (lat2 - lat1)/4
xlint = (lon2 - lon1)/4

xlint = math_int(math_abs(xlint))
ylint = math_int(math_abs(ylint))


'exec colors'
'set string 1 c 1 0'
*'set stid on'

***************************** Plot the Total Rainfall *****************************
'set mpdraw off'
*
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

varunit='mm'
if (nd <= 10 )
'set clevs 5 15 25 35 45 55 65 75 85 95 105 115 125 135'
endif

if (nd > 10 & nd <= 20)
'set clevs 5 15 30 45 60 75 90 105 120 135 150 165 180 195'
endif

if (nd > 20 & nd <= 45)
'set clevs 5 15 30 60 90 120 150 170 200 250 300 350 400 450'
endif

if (nd > 45 & nd <= 88)
'set clevs 10 25 50 75 100 125 150 200 250 275 350 450 550 650'
endif

if (nd > 88 & nd <= 100)
'set clevs 25 50 100 150 200 250 300 350 400 500 600 700 800 900'
endif

*if (nd > 100 & nd <= 180)
if (nd > 100)
*'set clevs 10 20 30 40 50 60 70 80 90 100 110 120 130 140'
'set clevs 5 10 30 50 70 90 110 130 150 170 190 210 230 250'
varunit='mm*10'
endif


'set ccols 0 31 33 35 37 39 41 43 45 47 49 21 23 25 27 28'

if(stnmark = 0)
 'd ptot'
else
* if (nd > 100 & nd <= 180)
 if (nd > 100)
  'd tpr*0.1*stnave(precip.1, time=date1,time=date2,-m 2)'
 else
  'd tpr*stnave(precip.1, time=date1,time=date2,-m 2)'
 endif
endif
** ------ Figure out where the title will go -------------------------
'q gxinfo'
xlims=sublin(result,3)
ylims=sublin(result,4)
ytop=subwrd(ylims,6)
xleft=subwrd(xlims,4)
xright=subwrd(xlims,6)
xmid=xleft+(xright-xleft)/2

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Total Rainfall ('varunit')'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'
'printim CONTRY_rev_stn_total_precip.png '
'!convert -trim -density 500 CONTRY_rev_stn_total_precip.png CONTRY_rev_stn_total_precip.png'
'c'



***************************** Plot the Total Rainfall Anomaly *****************************
varunit='mm'
'set mpdraw off'
*
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

if (nd <= 20)
'set clevs  -100 -75 -50 -25 -15 -5 5 15 25 50 75 100'
endif

if (nd > 20 & nd <= 45)
'set clevs  -150 -100 -75 -50 -25 -10 10 25 50 75 100 150'
endif

if (nd > 45 & nd <= 75)
'set clevs  -200 -150 -100 -75 -50 -25 25 50 75 100 150 200'
endif

if (nd > 75 & nd <= 100)
'set clevs  -330 -270 -210 -150 -90 -30 30 90 150 210 270 330'
endif

*if (nd > 100 & nd <= 180)
if (nd > 100)
'set clevs  -450 -350 -250 -175 -100 -60 60 100 175 250 350 450'
endif

'set ccols 21 78 76 75 74 72 0 31 34 39 42 44 49'
'set mpdraw off'

if(stnmark = 0)
 'd panom'
else
 'd tpr*stnave(precip.1, time=date1,time=date2,-m 2) - tpr*stnave(precip.2, time=date1,time=date2,-m 2)'
endif

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Total Precip Anomaly (mm)'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'

'printim CONTRY_rev_stn_precip_anomaly.png '
'!convert -trim -density 500 CONTRY_rev_stn_precip_anomaly.png CONTRY_rev_stn_precip_anomaly.png'
'clear'


***************************** Plot the Total Rainfall Climatology *****************************
'set mpdraw off'
*
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

varunit='mm'
if (nd <= 10 )
'set clevs 5 15 25 35 45 55 65 75 85 95 105 115 125 135'
endif

if (nd > 10 & nd <= 20)
'set clevs 5 15 30 45 60 75 90 105 120 135 150 165 180 195'
endif

if (nd > 20 & nd <= 45)
'set clevs 5 15 30 60 90 120 150 170 200 250 300 350 400 450'
endif

if (nd > 45 & nd <= 88)
'set clevs 10 25 50 75 100 125 150 200 250 275 350 450 550 650'
endif

if (nd > 88 & nd <= 100)
'set clevs 25 50 100 150 200 250 300 350 400 500 600 700 800 900'
endif

*if (nd > 100 & nd <= 180)
if (nd > 100)
*'set clevs 10 20 30 40 50 60 70 80 90 100 110 120 130 140'
'set clevs 5 10 30 50 70 90 110 130 150 170 190 210 230 250'
varunit='mm*10'
endif

'set ccols 0 31 33 35 37 39 41 43 45 47 49 21 23 25 27 28'

if(stnmark = 0)
 'd pclim'
else
* if (nd > 100 & nd <= 180)
 if (nd > 100)
  'd tpr*0.1*stnave(precip.2, time=date1,time=date2,-m 2)'
 else
  'd tpr*stnave(precip.2, time=date1,time=date2,-m 2)'
 endif
endif

'set string 2 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Total Precip ('varunit')'
'draw string 'xmid' 'ytop+0.125' Clim. Period: dateclm1 to dateclm2'

*'set strsiz 0.15'
*'draw string 4.25 9.0 xday Total Precip ('varunit')   date1 to date2'

'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'

'printim CONTRY_rev_stn_normal_precip.png '
'!convert -trim -density 500 CONTRY_rev_stn_normal_precip.png CONTRY_rev_stn_normal_precip.png'
'clear'


***************************** Plot the Percent Normal Rainfall *****************************
'set mpdraw off'
*
'set vpage 0.0 8.5 1.25 9.75'
'set xlint 'xlint''
'set ylint 'ylint''
'set grads off'
'set gxout stnmark'
'set cmark 3'
'set digsiz 0.35'
if(stnmark = 0)
 'set gxout shaded'
endif

'set clevs 0 25 50 80 120 200 400'
'set ccols 0 28 25 22 35 43 46 48'

if(stnmark = 0)
 'd pnorm'
else
 'd 100*stnave(precip.1,time=date1,time=date2, -m 2) / stnave(precip.2,time=date1,time=date2,-m 2)'
endif

'set string 1 c 5.5'
'set strsiz  0.125'
'draw string 'xmid' 'ytop+0.375' Station xday-Day Percent Normal Rainfall (%)'
'draw string 'xmid' 'ytop+0.125' Period: date1 to date2'

'set line 96 1 1'
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm2'
if(stnmark = 0)
 'set line 1 1 6'
endif
'draw shp ../ToolKit/gis_resources/countries/CNTRY_adm/CNTRY_adm1'

'xcbar_cpt -fw 0.1 -fh 0.13 -ft 6 -fs 1 -fo 0 -edge circle -line on'

'printim CONTRY_rev_stn_percent_normal_precip.png '
'!convert -trim -density 500 CONTRY_rev_stn_percent_normal_precip.png CONTRY_rev_stn_percent_normal_precip.png'
'clear'
*
'quit'
