        program read
c-----------------------------------------------------------
c ....  ny=number of years
c ....  ns=number of stations
c ....  ist=starting year of data
c ....  jdy=number of julian days (non leap years only)
c-----------------------------------------------------------
        parameter (ny=NYRS,ns=NSTNS,ist=STYR) ! **** Change this line as needed
        parameter (nm=12,ndm=31,ndy=366,ndyts=365)  ! Do not Change this line
c
        real bb(ns,ny,ndy),c(nm,ndm),val
        real bbts(ns,ny,ndyts), strdta(ns,366), cbbts(ns,ndyts)
        real xlat(ns),xlon(ns)
        integer yr, mn, lyy(ny), ids(nm),day
c        integer idsts(nm)
        integer mdxlmas(11), mdxlmbs(11), mdxlma(11), mdxlmb(11)
        character*8 stnn(ns)
c
        data ids/31,29,31,30,31,30,31,31,30,31,30,31/
c        data idsts/31,28,31,30,31,30,31,31,30,31,30,31/
        
        data mdxlmas/31,59,90,120,151,181,212,243,273,304,334/
        data mdxlmbs/32,60,91,121,152,182,213,244,274,305,335/
           
c..
c..****If needed, change following input and output file names  ****
c..
        open(10,file='stations.txt',
     1  form='formatted',status='old')
        open(21,file='formatted_data.txt',
     1  form='formatted',status='unknown')
        open(31,file='data_for_map.txt',
     1  form='formatted',status='unknown')
        open(33,file='data_clim_for_map.txt',
     1  form='formatted',status='unknown')
c
c-- Do not change below this line----------------------
c
        iyy = ist-1
        do iy= 1,ny
          iyy= iyy+1
          lyy(iy)= iyy
        enddo
c-----begin read------------------------
        do is = 1,ns
          read(10,103,err=555) xlat(is),xlon(is),stnn(is)
          print*, is, xlat(is), xlon(is), stnn(is)
          
          do iy = 1,ny
	       ixy1 = ist+iy-1	  
	       
           do im = 1,nm
            read(10,*,err=555) ixy,imy,(c(im,idm),idm=1,ndm)
	        print*, ixy,ixy1,imy,im
	        
	        if ((ixy1.ne.ixy).or.(imy.ne.im)) then
	         print*, 'In your data ..'
            print*, 'month or year for the station is out of sequence'
	         print*, stnn(is), ixy, imy
             stop
	        endif
	        
	        do idm = 1,ndm
	        
	         if ((c(im,idm).lt.0).and.(c(im,idm).ne.-99999.)) then
	          print*, 'there is bad data for ', stnn(is), ixy, imy
              stop
	         endif
	         
             if (c(im,idm).gt.999) then
	          print*, 'there is bad data for ', stnn(is), ixy, imy
              stop
	         endif
	         
	        enddo
	        
           enddo
c
           ic = 0
           do im = 1,nm
            idyy = ids(im)
c
            do idm = 1,idyy
             ic = ic+1
             bb(is,iy,ic) = c(im,idm)
c             if (im.eq.2) then
c              if (idm.lt.29) bbts(is,iy,ic) = c(im,idm)
c             else
c              bbts(is,iy,ic) = c(im,idm)
c             endif
            enddo
c
           enddo
c
          enddo
c
        enddo
        
 555    continue
	    print*, 'SUCCESS!! - NOW THE DATA IS READY FOR IN CMT'
	    
        bbts(1:ns,1:ny,1:59)=bb(1:ns,1:ny,1:59)
        bbts(1:ns,1:ny,60:365)=bb(1:ns,1:ny,61:366)
c
c--begin writing-----------------
        do is=1,ns
         write(21,103) xlat(is),xlon(is),stnn(is)
         write(21,105) (lyy(iy),iy=1,ny)
         do idy=1,ndyts
          write(21,333) (bbts(is,iy,idy),iy=1,ny)
         enddo
        enddo
        
c----------------- Compute climatological period ------------------------------
        do is=1,ns
         do idy=1,ndyts
          sum=0.0
          ic=0
          do iy=IDXBGCLM,IDXNDCLM
           if(bbts(is,iy,idy).gt.2500) bbts(is,iy,idy) = -99999.0
           if(bbts(is,iy,idy).eq.-99999.0) goto 224
            ic=ic+1
            sum=sum+bbts(is,iy,idy)
224       continue
          enddo
          
          cbbts(is,idy) = sum/float(ic)
          if(cbbts(is,idy).lt.0.0) cbbts(is,idy) = -99999.0
          
         enddo
        end do
        

        
        
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        day0=1
        
c----------------- saving climatological data ------------------------------
        mdxlma = mdxlmas
        mdxlmb = mdxlmbs
        do iy=1,2
         do idy=1,ndyts
            if (idy.le.31) im=1
            if ((idy.gt.31).and.(idy.le.mdxlma(2))) im=2
            if ((idy.gt.mdxlma(2)).and.(idy.le.mdxlma(3))) im=3
            if ((idy.gt.mdxlma(3)).and.(idy.le.mdxlma(4))) im=4
            if ((idy.gt.mdxlma(4)).and.(idy.le.mdxlma(5))) im=5
            if ((idy.gt.mdxlma(5)).and.(idy.le.mdxlma(6))) im=6
            if ((idy.gt.mdxlma(6)).and.(idy.le.mdxlma(7))) im=7
            if ((idy.gt.mdxlma(7)).and.(idy.le.mdxlma(8))) im=8
            if ((idy.gt.mdxlma(8)).and.(idy.le.mdxlma(9))) im=9
            if ((idy.gt.mdxlma(9)).and.(idy.le.mdxlma(10))) im=10
            if ((idy.gt.mdxlma(10)).and.(idy.le.mdxlma(11))) im=11
            if (idy.gt.mdxlma(11)) im=12

            if (idy.eq.1) day=day0
            if (idy.eq.32) day=day0
            if (idy.eq.mdxlmb(2)) day=day0
            if (idy.eq.mdxlmb(3)) day=day0
            if (idy.eq.mdxlmb(4)) day=day0
            if (idy.eq.mdxlmb(5)) day=day0
            if (idy.eq.mdxlmb(6)) day=day0
            if (idy.eq.mdxlmb(7)) day=day0
            if (idy.eq.mdxlmb(8)) day=day0
            if (idy.eq.mdxlmb(9)) day=day0
            if (idy.eq.mdxlmb(10)) day=day0
            if (idy.eq.mdxlmb(11)) day=day0
            
            do is=1,ns
              val=cbbts(is,idy)
             write(33,200) lyy(iy), im, day, is, xlat(is), xlon(is), val
            enddo
            day=day+1
         enddo
        
        enddo
        
        
        
        
        do iy=1,ny
        
            mdxlma = mdxlmas+1 
            mdxlmb = mdxlmbs+1
            ndyyr  = ndy
            
           if(mod(lyy(iy),100).ne.0.and.mod(lyy(iy),4).eq.0) then
c            write(*,*) 'LEAP YEAR' 
            strdta(1:ns,1:366)=bb(1:ns,iy,1:366)
           elseif(mod(lyy(iy),400).eq.0) then
c            write(*,*) 'LEAP YEAR'
            strdta(1:ns,1:366)=bb(1:ns,iy,1:366)
           else 
c            write(*,*) 'NOT A LEAP YEAR' 
            strdta(1:ns,1:59)=bb(1:ns,iy,1:59)
            strdta(1:ns,60:365)=bb(1:ns,iy,61:366)
            mdxlma = mdxlmas
            mdxlmb = mdxlmbs
            ndyyr  = ndy - 1
           endif
           

           do idy=1,ndyyr
           
            if (idy.le.31) im=1
            if ((idy.gt.31).and.(idy.le.mdxlma(2))) im=2
            if ((idy.gt.mdxlma(2)).and.(idy.le.mdxlma(3))) im=3
            if ((idy.gt.mdxlma(3)).and.(idy.le.mdxlma(4))) im=4
            if ((idy.gt.mdxlma(4)).and.(idy.le.mdxlma(5))) im=5
            if ((idy.gt.mdxlma(5)).and.(idy.le.mdxlma(6))) im=6
            if ((idy.gt.mdxlma(6)).and.(idy.le.mdxlma(7))) im=7
            if ((idy.gt.mdxlma(7)).and.(idy.le.mdxlma(8))) im=8
            if ((idy.gt.mdxlma(8)).and.(idy.le.mdxlma(9))) im=9
            if ((idy.gt.mdxlma(9)).and.(idy.le.mdxlma(10))) im=10
            if ((idy.gt.mdxlma(10)).and.(idy.le.mdxlma(11))) im=11
            if (idy.gt.mdxlma(11)) im=12

            if (idy.eq.1) day=day0
            if (idy.eq.32) day=day0
            if (idy.eq.mdxlmb(2)) day=day0
            if (idy.eq.mdxlmb(3)) day=day0
            if (idy.eq.mdxlmb(4)) day=day0
            if (idy.eq.mdxlmb(5)) day=day0
            if (idy.eq.mdxlmb(6)) day=day0
            if (idy.eq.mdxlmb(7)) day=day0
            if (idy.eq.mdxlmb(8)) day=day0
            if (idy.eq.mdxlmb(9)) day=day0
            if (idy.eq.mdxlmb(10)) day=day0
            if (idy.eq.mdxlmb(11)) day=day0

            do is=1,ns
c              val=bb(is,iy,idy)
              val=strdta(is,idy)
c             write(31,201) lyy(iy), im, day, stnn(is), xlat(is), xlon(is), val
             write(31,200) lyy(iy), im, day, is, xlat(is), xlon(is), val
            enddo
            day=day+1
           enddo
           
           
           
           
        enddo
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        
c-----------------
c 101    format(i4,2i4,2f10.2,i7,f9.3)
c 103    format(2f10.2,a8)
 103    format(f10.2,1x,f10.2,1x,a8)
 105    format(NYRSi10)
 333    format(NYRSf10.2)
 200    format(i4,2x,i4,2x,i4,5x,i7,5x,f10.2,5x,f10.2,5x,f10.3)
 201    format(i4,2x,i4,2x,i4,5x,a8,5x,f10.2,5x,f10.2,5x,f10.3)

c
        stop
        end
